## ocamlbuild 0.11.0

=== Makefile ===
#########################################################################
#                                                                       #
#                                 OCaml                                 #
#                                                                       #
#   Nicolas Pouillard, Berke Durak, projet Gallium, INRIA Rocquencourt  #
#                                                                       #
#   Copyright 2007 Institut National de Recherche en Informatique et    #
#   en Automatique.  All rights reserved.  This file is distributed     #
#  under the terms of the GNU Library General Public License, with      #
#  the special exception on linking described in file ../LICENSE.       #
#                                                                       #
#########################################################################

# see 'check-if-preinstalled' target
CHECK_IF_PREINSTALLED ?= true

# this configuration file is generated from configure.make
include Makefile.config

ifeq ($(OCAML_NATIVE_TOOLS), true)
OCAMLC    ?= ocamlc.opt
OCAMLOPT  ?= ocamlopt.opt
OCAMLDEP  ?= ocamldep.opt
OCAMLLEX  ?= ocamllex.opt
else
OCAMLC    ?= ocamlc
OCAMLOPT  ?= ocamlopt
OCAMLDEP  ?= ocamldep
OCAMLLEX  ?= ocamllex
endif

CP        ?= cp
COMPFLAGS ?= -w L -w R -w Z -I src -I +unix -safe-string -bin-annot
LINKFLAGS ?= -I +unix -I src

PACK_CMO= $(addprefix src/,\
  const.cmo \
  loc.cmo \
  discard_printf.cmo \
  signatures.cmi \
  my_std.cmo \
  my_unix.cmo \
  tags.cmo \
  display.cmo \
  log.cmo \
  shell.cmo \
  bool.cmo \
  glob_ast.cmo \
  glob_lexer.cmo \
  glob.cmo \
  lexers.cmo \
  param_tags.cmo \
  command.cmo \
  ocamlbuild_config.cmo \
  ocamlbuild_where.cmo \
  slurp.cmo \
  options.cmo \
  pathname.cmo \
  configuration.cmo \
  flags.cmo \
  hygiene.cmo \
  digest_cache.cmo \
  resource.cmo \
  rule.cmo \
  solver.cmo \
  report.cmo \
  tools.cmo \
  fda.cmo \
  findlib.cmo \
  ocaml_arch.cmo \
  ocaml_utils.cmo \
  ocaml_dependencies.cmo \
  ocaml_compiler.cmo \
  ocaml_tools.cmo \
  ocaml_specific.cmo \
  exit_codes.cmo \
  plugin.cmo \
  hooks.cmo \
  main.cmo \
  )

EXTRA_CMO=$(addprefix src/,\
  ocamlbuild_plugin.cmo \
  ocamlbuild_executor.cmo \
  ocamlbuild_unix_plugin.cmo \
  )

PACK_CMX=$(PACK_CMO:.cmo=.cmx)
EXTRA_CMX=$(EXTRA_CMO:.cmo=.cmx)
EXTRA_CMI=$(EXTRA_CMO:.cmo=.cmi)

INSTALL_LIB=\
  src/ocamlbuildlib.cma \
  src/ocamlbuild.cmo \
  src/ocamlbuild_pack.cmi \
  $(EXTRA_CMO:.cmo=.cmi)

INSTALL_LIB_OPT=\
  src/ocamlbuildlib.cmxa src/ocamlbuildlib$(EXT_LIB) \
  src/ocamlbuild.cmx src/ocamlbuild$(EXT_OBJ) \
  src/ocamlbuild_pack.cmx \
  $(EXTRA_CMO:.cmo=.cmx) $(EXTRA_CMO:.cmo=$(EXT_OBJ))

INSTALL_LIBDIR=$(DESTDIR)$(LIBDIR)
INSTALL_BINDIR=$(DESTDIR)$(BINDIR)
INSTALL_MANDIR=$(DESTDIR)$(MANDIR)

ifeq ($(OCAML_NATIVE), true)
all: byte native man
else
all: byte man
endif

byte: ocamlbuild.byte src/ocamlbuildlib.cma
                 # ocamlbuildlight.byte ocamlbuildlightlib.cma
native: ocamlbuild.native src/ocamlbuildlib.cmxa

allopt: all # compatibility alias

distclean:: clean

# The executables

ocamlbuild.byte: src/ocamlbuild_pack.cmo $(EXTRA_CMO) src/ocamlbuild.cmo
	$(OCAMLC) $(LINKFLAGS) -o $@ unix.cma $^

ocamlbuildlight.byte: src/ocamlbuild_pack.cmo src/ocamlbuildlight.cmo
	$(OCAMLC) $(LINKFLAGS) -o $@ $^

ocamlbuild.native: src/ocamlbuild_pack.cmx $(EXTRA_CMX) src/ocamlbuild.cmx
	$(OCAMLOPT) $(LINKFLAGS) -o $@ unix.cmxa $^

# The libraries

src/ocamlbuildlib.cma: src/ocamlbuild_pack.cmo $(EXTRA_CMO)
	$(OCAMLC) -a -o $@ $^

src/ocamlbuildlightlib.cma: src/ocamlbuild_pack.cmo src/ocamlbuildlight.cmo
	$(OCAMLC) -a -o $@ $^

src/ocamlbuildlib.cmxa: src/ocamlbuild_pack.cmx $(EXTRA_CMX)
	$(OCAMLOPT) -a -o $@ $^

# The packs

# Build artifacts are first placed into tmp/ to avoid a race condition
# described in https://caml.inria.fr/mantis/view.php?id=4991.

src/ocamlbuild_pack.cmo: $(PACK_CMO)
	mkdir -p tmp
	$(OCAMLC) -pack $^ -o tmp/ocamlbuild_pack.cmo
	mv tmp/ocamlbuild_pack.cmi src/ocamlbuild_pack.cmi
	mv tmp/ocamlbuild_pack.cmo src/ocamlbuild_pack.cmo

src/ocamlbuild_pack.cmi: src/ocamlbuild_pack.cmo

src/ocamlbuild_pack.cmx: $(PACK_CMX)
	mkdir -p tmp
	$(OCAMLOPT) -pack $^ -o tmp/ocamlbuild_pack.cmx
	mv tmp/ocamlbuild_pack.cmx src/ocamlbuild_pack.cmx
	mv tmp/ocamlbuild_pack.o src/ocamlbuild_pack.o

# The lexers

src/lexers.ml: src/lexers.mll
	$(OCAMLLEX) src/lexers.mll
clean::
	rm -f src/lexers.ml
beforedepend:: src/lexers.ml

src/glob_lexer.ml: src/glob_lexer.mll
	$(OCAMLLEX) src/glob_lexer.mll
clean::
	rm -f src/glob_lexer.ml
beforedepend:: src/glob_lexer.ml

# The config file

configure:
	$(MAKE) -f configure.make all

# proxy rule for rebuilding configuration files directly from the main Makefile
Makefile.config src/ocamlbuild_config.ml:
	$(MAKE) -f configure.make $@

clean::
	$(MAKE) -f configure.make clean

distclean::
	$(MAKE) -f configure.make distclean

beforedepend:: src/ocamlbuild_config.ml

# man page

man: man/ocamlbuild.1

man/ocamlbuild.1: man/ocamlbuild.header.1 man/ocamlbuild.options.1 man/ocamlbuild.footer.1
	cat $^ > man/ocamlbuild.1

man/ocamlbuild.options.1: man/options_man.byte
	./man/options_man.byte > man/ocamlbuild.options.1

clean::
	rm -f man/ocamlbuild.options.1

distclean::
	rm -f man/ocamlbuild.1

man/options_man.byte: src/ocamlbuild_pack.cmo
	$(OCAMLC) $^ -I src man/options_man.ml -o man/options_man.byte

clean::
	rm -f man/options_man.cm*
	rm -f man/options_man.byte
ifdef EXT_OBJ
	rm -f man/options_man$(EXT_OBJ)
endif

# Testing

test-%: testsuite/%.ml all
	cd testsuite && ocaml $(CURDIR)/$<

test: test-internal test-findlibonly test-external

clean::
	rm -rf testsuite/_test_*

# Installation

# The binaries go in BINDIR. We copy ocamlbuild.byte and
# ocamlbuild.native (if available), and also copy the best available
# binary as BINDIR/ocamlbuild.

# The library is put in LIBDIR/ocamlbuild. We copy
# - the META file (for ocamlfind)
# - src/signatures.mli (user documentation)
# - the files in INSTALL_LIB and INSTALL_LIB_OPT (if available)

# We support three installation methods:
# - standard {install,uninstall} targets
# - findlib-{install,uninstall} that uses findlib for the library install
# - producing an OPAM .install file and not actually installing anything

install-bin-byte:
	mkdir -p $(INSTALL_BINDIR)
	$(CP) ocamlbuild.byte $(INSTALL_BINDIR)/ocamlbuild.byte$(EXE)
ifneq ($(OCAML_NATIVE), true)
	$(CP) ocamlbuild.byte $(INSTALL_BINDIR)/ocamlbuild$(EXE)
endif

install-bin-native:
	mkdir -p $(INSTALL_BINDIR)
	$(CP) ocamlbuild.native $(INSTALL_BINDIR)/ocamlbuild$(EXE)
	$(CP) ocamlbuild.native $(INSTALL_BINDIR)/ocamlbuild.native$(EXE)

ifeq ($(OCAML_NATIVE), true)
install-bin: install-bin-byte install-bin-native
else
install-bin: install-bin-byte
endif

install-bin-opam:
	echo 'bin: [' >> ocamlbuild.install
	echo '  "ocamlbuild.byte" {"ocamlbuild.byte"}' >> ocamlbuild.install
ifeq ($(OCAML_NATIVE), true)
	echo '  "ocamlbuild.native" {"ocamlbuild.native"}' >> ocamlbuild.install
	echo '  "ocamlbuild.native" {"ocamlbuild"}' >> ocamlbuild.install
else
	echo '  "ocamlbuild.byte" {"ocamlbuild"}' >> ocamlbuild.install
endif
	echo ']' >> ocamlbuild.install
	echo >> ocamlbuild.install

install-lib-basics:
	mkdir -p $(INSTALL_LIBDIR)/ocamlbuild
	$(CP) META src/signatures.mli $(INSTALL_LIBDIR)/ocamlbuild

install-lib-basics-opam:
	echo '  "opam"' >> ocamlbuild.install
	echo '  "META"' >> ocamlbuild.install
	echo '  "src/signatures.mli" {"signatures.mli"}' >> ocamlbuild.install

install-lib-byte:
	mkdir -p $(INSTALL_LIBDIR)/ocamlbuild
	$(CP) $(INSTALL_LIB) $(INSTALL_LIBDIR)/ocamlbuild

install-lib-byte-opam:
	for lib in $(INSTALL_LIB); do \
	  echo "  \"$$lib\" {\"$$(basename $$lib)\"}" >> ocamlbuild.install; \
	done

install-lib-native:
	mkdir -p $(INSTALL_LIBDIR)/ocamlbuild
	$(CP) $(INSTALL_LIB_OPT) $(INSTALL_LIBDIR)/ocamlbuild

install-lib-native-opam:
	for lib in $(INSTALL_LIB_OPT); do \
	  echo "  \"$$lib\" {\"$$(basename $$lib)\"}" >> ocamlbuild.install; \
	done

ifeq ($(OCAML_NATIVE), true)
install-lib: install-lib-basics install-lib-byte install-lib-native
else
install-lib: install-lib-basics install-lib-byte
endif

install-lib-findlib:
ifeq ($(OCAML_NATIVE), true)
	ocamlfind install ocamlbuild \
	  META src/signatures.mli $(INSTALL_LIB) $(INSTALL_LIB_OPT)
else
	ocamlfind install ocamlbuild \
	  META src/signatures.mli $(INSTALL_LIB)
endif

install-lib-opam:
	echo 'lib: [' >> ocamlbuild.install
	$(MAKE) install-lib-basics-opam
	$(MAKE) install-lib-byte-opam
ifeq ($(OCAML_NATIVE), true)
	$(MAKE) install-lib-native-opam
endif
	echo ']' >> ocamlbuild.install
	echo >> ocamlbuild.install

install-man:
	mkdir -p $(INSTALL_MANDIR)/man1
	cp man/ocamlbuild.1 $(INSTALL_MANDIR)/man1/ocamlbuild.1

install-man-opam:
	echo 'man: [' >> ocamlbuild.install
	echo '  "man/ocamlbuild.1" {"man1/ocamlbuild.1"}' >> ocamlbuild.install
	echo ']' >> ocamlbuild.install
	echo >> ocamlbuild.install

install-doc-opam:
	echo 'docdir: [' >> ocamlbuild.install
	echo '  "LICENSE"' >> ocamlbuild.install
	echo '  "Changes"' >> ocamlbuild.install
	echo '  "Readme.md"' >> ocamlbuild.install
	echo ']' >> ocamlbuild.install

uninstall-bin:
	rm $(BINDIR)/ocamlbuild
	rm $(BINDIR)/ocamlbuild.byte
ifeq ($(OCAML_NATIVE), true)
	rm $(BINDIR)/ocamlbuild.native
endif

uninstall-lib-basics:
	rm $(LIBDIR)/ocamlbuild/META $(LIBDIR)/ocamlbuild/signatures.mli

uninstall-lib-byte:
	for lib in $(INSTALL_LIB); do\
	  rm $(LIBDIR)/ocamlbuild/`basename $$lib`;\
	done

uninstall-lib-native:
	for lib in $(INSTALL_LIB_OPT); do\
	  rm $(LIBDIR)/ocamlbuild/`basename $$lib`;\
	done

uninstall-lib:
	$(MAKE) uninstall-lib-basics uninstall-lib-byte
ifeq ($(OCAML_NATIVE), true)
	$(MAKE) uninstall-lib-native
endif
	ls $(LIBDIR)/ocamlbuild # for easier debugging if rmdir fails
	rmdir $(LIBDIR)/ocamlbuild

uninstall-lib-findlib:
	ocamlfind remove ocamlbuild

uninstall-man:
	rm $(INSTALL_MANDIR)/man1/ocamlbuild.1

install: check-if-preinstalled
	$(MAKE) install-bin install-lib install-man
uninstall: uninstall-bin uninstall-lib uninstall-man

findlib-install: check-if-preinstalled
	$(MAKE) install-bin install-lib-findlib
findlib-uninstall: uninstall-bin uninstall-lib-findlib

opam-install: check-if-preinstalled
	$(MAKE) ocamlbuild.install

ocamlbuild.install:
	rm -f ocamlbuild.install
	touch ocamlbuild.install
	$(MAKE) install-bin-opam
	$(MAKE) install-lib-opam
	$(MAKE) install-man-opam
	$(MAKE) install-doc-opam

check-if-preinstalled:
ifeq ($(CHECK_IF_PREINSTALLED), true)
	if test -d $(shell ocamlc -where)/ocamlbuild; then\
	  >&2 echo "ERROR: Preinstalled ocamlbuild detected at"\
	       "$(shell ocamlc -where)/ocamlbuild";\
	  >&2 echo "Installation aborted; if you want to bypass this"\
	        "safety check, pass CHECK_IF_PREINSTALLED=false to make";\
	  exit 2;\
	fi
endif

# The generic rules

%.cmo: %.ml
	$(OCAMLC) $(COMPFLAGS) -c $<

%.cmi: %.mli
	$(OCAMLC) $(COMPFLAGS) -c $<

%.cmx: %.ml
	$(OCAMLOPT) -for-pack Ocamlbuild_pack $(COMPFLAGS) -c $<

clean::
	rm -rf tmp/
	rm -f src/*.cm* *.cm*
ifdef EXT_OBJ
	rm -f src/*$(EXT_OBJ) *$(EXT_OBJ)
endif
ifdef EXT_LIB
	rm -f src/*$(EXT_LIB) *$(EXT_LIB)
endif
	rm -f test/test2/vivi.ml

distclean::
	rm -f ocamlbuild.byte ocamlbuild.native
	rm -f ocamlbuild.install

# The dependencies

depend: beforedepend
	$(OCAMLDEP) -I src src/*.mli src/*.ml > .depend

$(EXTRA_CMI): src/ocamlbuild_pack.cmi
$(EXTRA_CMO): src/ocamlbuild_pack.cmo src/ocamlbuild_pack.cmi
$(EXTRA_CMX): src/ocamlbuild_pack.cmx src/ocamlbuild_pack.cmi

include .depend

.PHONY: all allopt beforedepend clean configure
.PHONY: install installopt installopt_really depend

=== examples/01-simple/Makefile ===
#
# Pure OCaml, no packages, no _tags
#

# bin-annot is required for Merlin and other IDE-like tools

OCB_FLAGS = -tag bin_annot
OCB = 		ocamlbuild $(OCB_FLAGS)

all: 		native byte # profile debug

clean:
			$(OCB) -clean

native:
			$(OCB) main.native

byte:
			$(OCB) main.byte

profile:
			$(OCB) -tag profile main.native

debug:
			$(OCB) -tag debug main.byte

test: 		native
			./main.native "OCaml" "OCamlBuild" "users"

.PHONY: 	all clean byte native profile debug test

=== examples/03-packages/Makefile ===
#
# Pure OCaml, package from Opam, two directories
#

# - The -I flag introduces sub-directories
# - -use-ocamlfind is required to find packages (from Opam)
# - _tags file introduces packages, bin_annot flag for tool chain

OCB_FLAGS = -use-ocamlfind -I src -I lib
OCB = 		ocamlbuild $(OCB_FLAGS)

all: 		native byte # profile debug

clean:
			$(OCB) -clean

native: 	sanity
			$(OCB) main.native

byte:		sanity
			$(OCB) main.byte

profile: 	sanity
			$(OCB) -tag profile main.native

debug: 		sanity
			$(OCB) -tag debug main.byte

sanity:
			# check that packages can be found
			ocamlfind query yojson

test: 		native
			echo '[1, 2, "three", {"four": 4}]' | ./main.native

.PHONY: 	all clean byte native profile debug sanity test

=== examples/04-library/Makefile ===
#
# Pure OCaml, package from Opam, two directories
#

# - The -I flag introduces sub-directories
# - -use-ocamlfind is required to find packages (from Opam)
# - _tags file introduces packages, bin_annot

OCB_FLAGS = -use-ocamlfind -I src -I libdemo
OCB = 		ocamlbuild $(OCB_FLAGS)

all: 		native byte lib # profile debug

clean:
			$(OCB) -clean

lib:
			$(OCB) libdemo.cma
			$(OCB) libdemo.cmxa
			$(OCB) libdemo.cmxs

native:  	sanity
			$(OCB) main.native

byte: 		sanity
			$(OCB) main.byte

profile: 	sanity
			$(OCB) -tag profile main.native

debug: 		sanity
			$(OCB) -tag debug main.byte

sanity:
			ocamlfind query yojson
			
test: 		native
			echo '{"hello": "json"}' | ./main.native

.PHONY: 	all clean byte native profile debug lib sanity test

=== examples/06-ocamldoc/Makefile ===
#
# Pure OCaml, no packages, no _tags, code in serveral directories
# Targets starting with "doc_" generate documentation for the Util and Hello
# modules
#

# bin-annot is required for Merlin and other IDE-like tools
# The -I flag introduces sub-directories to search for code

OCB_FLAGS = -tag bin_annot -I src -I lib
OCB = 		ocamlbuild $(OCB_FLAGS)

all: 		native byte # profile debug

clean:
			$(OCB) -clean

native:
			$(OCB) main.native

byte:
			$(OCB) main.byte

profile:
			$(OCB) -tag profile main.native

debug:
			$(OCB) -tag debug main.byte

doc_html:
			$(OCB) doc/api.docdir/index.html

doc_man:
			$(OCB) doc/api.docdir/man

doc_tex:
# the name of the .tex file can be anything
			$(OCB) doc/api.docdir/api.tex

doc_texinfo:
# the name of the .texi file can be anything
			$(OCB) doc/api.docdir/api.texi

doc_dot:
# the .dot graph represents inter-module dependencies
# as before, the name doesn't matter
			$(OCB) doc/api.docdir/api.dot

test: 		native
			./main.native "OCaml" "OCamlBuild" "users"


.PHONY: 	all clean byte native profile debug test

## ocamlbuild 0.10.1

=== debian/changelog ===
ocamlbuild (0.10.1-1) experimental; urgency=medium

  * Add an explicit versioned dependency on ocaml-nox to work around
    bug involving Debian build dependency parsing. (Closes: #843868)
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sat, 04 Mar 2017 15:34:54 +0100

ocamlbuild (0.9.3-3) experimental; urgency=medium

  * Force a rebuild against OCaml 4.03.0 on all architectures.
    (Closes: #842713)

 -- Ximin Luo <infinity0@debian.org>  Wed, 02 Nov 2016 13:28:14 +0100

ocamlbuild (0.9.3-2) experimental; urgency=medium

  * Rebuild against OCaml 4.03.0.
  * Use dh_ocaml to add the correct OCaml library dependencies.

 -- Ximin Luo <infinity0@debian.org>  Mon, 31 Oct 2016 08:00:20 +0100

ocamlbuild (0.9.3-1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Thu, 20 Oct 2016 20:38:36 +0200

ocamlbuild (0.9.2-1) experimental; urgency=medium

  * Initial release (Closes: #839099)

 -- Ximin Luo <infinity0@debian.org>  Thu, 20 Oct 2016 18:51:10 +0200

=== debian/control ===
Source: ocamlbuild
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Ximin Luo <infinity0@debian.org>
Build-Depends: debhelper (>= 9), dh-ocaml,
 ocaml-nox (>= 4.04.0)
Standards-Version: 3.9.8
Homepage: https://github.com/ocaml/ocamlbuild/
Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocamlbuild.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/ocamlbuild.git

Package: ocamlbuild
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${F:OCamlRun}, ${ocaml:Depends}
Provides: ${ocaml:Provides}
Replaces: libfindlib-ocaml (<< 1.6.3-1), ocaml-nox (<< 4.03.0-1)
Breaks: libfindlib-ocaml (<< 1.6.3-1), ocaml-nox (<< 4.03.0-1)
Description: Build tool for building OCaml library and programs
 OCamlbuild is a generic build tool, that has built-in rules for building OCaml
 library and programs.
 .
 It was distributed as part of the OCaml distribution for OCaml versions
 between 3.10.0 and 4.02.3. Starting from OCaml 4.03, it is now released
 separately.
 .
 Its job is to determine the sequence of calls to the compilerâ€‰â€”â€‰with the
 right set of command-line flagsâ€‰â€”â€‰needed to build your OCaml-centric
 software project.
 .
 It was designed as a generic build system (it is in fact not OCaml-specific),
 but also to be expressive enough to cover the specifics of the OCaml language
 that make writing good Makefiles difficult, such as the dreaded units Foo and
 Bar make inconsistent assumptions about Baz error.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


%:
	dh $@ --with ocaml
# TODO: Add a lintian check: if any package contains .cmi files then it should
# have a Depends: ocaml-base-nox or something like that (ask the list first).

# see https://pkg-ocaml-maint.alioth.debian.org/ocaml_packaging_policy.txt
OCAMLABI = $(shell ocamlc -version)
# to test a bytecode build on an architecture with ocamlopt, set this to "yes"
BYTECODE = $(shell [ -x /usr/bin/ocamlopt ] || echo yes)
OCAMLRUN = $(if $(BYTECODE),ocaml-base-nox-$(OCAMLABI))
OCAML_NATIVE = $(if $(BYTECODE),false,true)

OCAMLBUILD_CFG = \
 OCAMLBUILD_PREFIX=/usr \
 OCAMLBUILD_BINDIR=/usr/bin \
 OCAMLBUILD_LIBDIR=/usr/lib/ocaml

override_dh_auto_configure:
	$(MAKE) $(OCAMLBUILD_CFG) OCAML_NATIVE=$(OCAML_NATIVE) configure

override_dh_auto_install:
	dh_auto_install -- CHECK_IF_PREINSTALLED=false
	cd debian/ocamlbuild/usr/bin && rm -f ocamlbuild.byte ocamlbuild.native

override_dh_auto_clean:
	dh_auto_clean
	find . -name '*.cmti' -delete

override_dh_gencontrol:
	dh_gencontrol -- -VF:OCamlRun="$(OCAMLRUN)"

## ocamlbuild 0.11.0

=== debian/changelog ===
ocamlbuild (0.11.0-3build1) bionic; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Oct 2017 15:13:28 +0200

ocamlbuild (0.11.0-3) unstable; urgency=medium

  * Upload to unstable.
  * Update condition-nativeonly-tests.patch to be cleaner.

 -- Ximin Luo <infinity0@debian.org>  Sat, 16 Sep 2017 13:51:37 +0200

ocamlbuild (0.11.0-2) experimental; urgency=medium

  * Only run native tests if ocamlopt is available, fixes FTBFS on arches
    without ocamlopt.
  * Suppress "bss-plt forced" warnings from ld, fixes FTBFS on powerpc.

 -- Ximin Luo <infinity0@debian.org>  Sun, 30 Jul 2017 14:13:35 +0200

ocamlbuild (0.11.0-1) experimental; urgency=medium

  * New upstream release.
  * Update to latest Standards-Version; no changes required.

 -- Ximin Luo <infinity0@debian.org>  Sat, 29 Jul 2017 16:56:50 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,10 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Ximin Luo <infinity0@debian.org>
 Build-Depends: debhelper (>= 9), dh-ocaml,
- ocaml-nox (>= 4.04.0)
-Standards-Version: 3.9.8
+ ocaml-nox (>= 4.04.0),
+ ocaml-findlib (>= 1.7.3),
+ libfindlib-ocaml-dev (>= 1.7.3),
+Standards-Version: 4.0.0
 Homepage: https://github.com/ocaml/ocamlbuild/
 Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocamlbuild.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/ocamlbuild.git

## ocamlbuild 0.14.0

=== Makefile ===
--- 
+++ 
@@ -30,7 +30,7 @@
 endif
 
 CP        ?= cp
-COMPFLAGS ?= -w L -w R -w Z -I src -I +unix -safe-string -bin-annot
+COMPFLAGS ?= -w L -w R -w Z -I src -I +unix -safe-string -bin-annot -strict-sequence
 LINKFLAGS ?= -I +unix -I src
 
 PACK_CMO= $(addprefix src/,\
@@ -105,6 +105,11 @@
 INSTALL_BINDIR=$(DESTDIR)$(BINDIR)
 INSTALL_MANDIR=$(DESTDIR)$(MANDIR)
 
+INSTALL_SIGNATURES=\
+  src/signatures.mli \
+  src/signatures.cmi \
+  src/signatures.cmti
+
 ifeq ($(OCAML_NATIVE), true)
 all: byte native man
 else
@@ -158,7 +163,7 @@
 	mkdir -p tmp
 	$(OCAMLOPT) -pack $^ -o tmp/ocamlbuild_pack.cmx
 	mv tmp/ocamlbuild_pack.cmx src/ocamlbuild_pack.cmx
-	mv tmp/ocamlbuild_pack.o src/ocamlbuild_pack.o
+	mv tmp/ocamlbuild_pack$(EXT_OBJ) src/ocamlbuild_pack$(EXT_OBJ)
 
 # The lexers
 
@@ -235,7 +240,7 @@
 
 # The library is put in LIBDIR/ocamlbuild. We copy
 # - the META file (for ocamlfind)
-# - src/signatures.mli (user documentation)
+# - src/signatures.{mli,cmi,cmti} (user documentation)
 # - the files in INSTALL_LIB and INSTALL_LIB_OPT (if available)
 
 # We support three installation methods:
@@ -275,12 +280,14 @@
 
 install-lib-basics:
 	mkdir -p $(INSTALL_LIBDIR)/ocamlbuild
-	$(CP) META src/signatures.mli $(INSTALL_LIBDIR)/ocamlbuild
+	$(CP) META $(INSTALL_SIGNATURES) $(INSTALL_LIBDIR)/ocamlbuild
 
 install-lib-basics-opam:
-	echo '  "opam"' >> ocamlbuild.install
+	echo '  "ocamlbuild.opam" {"opam"}' >> ocamlbuild.install
 	echo '  "META"' >> ocamlbuild.install
-	echo '  "src/signatures.mli" {"signatures.mli"}' >> ocamlbuild.install
+	for lib in $(INSTALL_SIGNATURES); do \
+	  echo "  \"$$lib\" {\"$$(basename $$lib)\"}" >> ocamlbuild.install; \
+	done
 
 install-lib-byte:
 	mkdir -p $(INSTALL_LIBDIR)/ocamlbuild
@@ -309,10 +316,10 @@
 install-lib-findlib:
 ifeq ($(OCAML_NATIVE), true)
 	ocamlfind install ocamlbuild \
-	  META src/signatures.mli $(INSTALL_LIB) $(INSTALL_LIB_OPT)
+	  META $(INSTALL_SIGNATURES) $(INSTALL_LIB) $(INSTALL_LIB_OPT)
 else
 	ocamlfind install ocamlbuild \
-	  META src/signatures.mli $(INSTALL_LIB)
+	  META $(INSTALL_SIGNATURES) $(INSTALL_LIB)
 endif
 
 install-lib-opam:
@@ -336,7 +343,7 @@
 	echo >> ocamlbuild.install
 
 install-doc-opam:
-	echo 'docdir: [' >> ocamlbuild.install
+	echo 'doc: [' >> ocamlbuild.install
 	echo '  "LICENSE"' >> ocamlbuild.install
 	echo '  "Changes"' >> ocamlbuild.install
 	echo '  "Readme.md"' >> ocamlbuild.install
@@ -350,7 +357,10 @@
 endif
 
 uninstall-lib-basics:
-	rm $(LIBDIR)/ocamlbuild/META $(LIBDIR)/ocamlbuild/signatures.mli
+	rm $(LIBDIR)/ocamlbuild/META
+	for lib in $(INSTALL_SIGNATURES); do \
+	  rm $(LIBDIR)/ocamlbuild/`basename $$lib`;\
+	done
 
 uninstall-lib-byte:
 	for lib in $(INSTALL_LIB); do\

=== debian/changelog ===
ocamlbuild (0.14.0-2) unstable; urgency=medium

  * Team upload
  * Include ocamlvars.mk to avoid failure in dh_dwz
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Tue, 11 Aug 2020 17:58:42 +0200

ocamlbuild (0.14.0-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * New upstream release
  * Update Vcs-*
  * Bump Standards-Version to 4.4.0
  * Bump debhelper compat level to 12

  [ Ralf Treinen ]
  * Package description: remove strange characters, minor improvements of
    wording (closes: #876000)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 04 Aug 2019 05:28:26 +0200

=== debian/control ===
Source: ocamlbuild
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Ximin Luo <infinity0@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-ocaml,
 ocaml-nox (>= 4.04.0),
 ocaml-findlib (>= 1.7.3),
 libfindlib-ocaml-dev (>= 1.7.3),
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://github.com/ocaml/ocamlbuild/
Vcs-Git: https://salsa.debian.org/ocaml-team/ocamlbuild.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/ocamlbuild

Package: ocamlbuild
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${F:OCamlRun}, ${ocaml:Depends}
Provides: ${ocaml:Provides}
Replaces: libfindlib-ocaml (<< 1.6.3-1), ocaml-nox (<< 4.03.0-1)
Breaks: libfindlib-ocaml (<< 1.6.3-1), ocaml-nox (<< 4.03.0-1)
Description: Build tool for building OCaml libraries and programs
 OCamlbuild is a generic build tool, which has built-in rules for building OCaml
 libraries and programs.
 .
 It was distributed as part of the OCaml distribution for OCaml versions
 between 3.10.0 and 4.02.3. Starting from OCaml 4.03, it is now released
 separately.
 .
 Its job is to determine the sequence of calls to the compiler with the
 right set of command-line flags needed to build your OCaml-centric
 software project.
 .
 It was designed as a generic build system (it is in fact not OCaml-specific),
 but also to be expressive enough to cover the specifics of the OCaml language
 that make writing good Makefiles difficult, such as the dreaded "units Foo and
 Bar make inconsistent assumptions about Baz" error.

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,8 @@
 # output every command that modifies files on the build system.
 #export DH_VERBOSE = 1
 
+include /usr/share/dpkg/architecture.mk
+include /usr/share/ocaml/ocamlvars.mk
 
 %:
 	dh $@ --with ocaml
@@ -19,7 +21,19 @@
 OCAMLBUILD_CFG = \
  OCAMLBUILD_PREFIX=/usr \
  OCAMLBUILD_BINDIR=/usr/bin \
- OCAMLBUILD_LIBDIR=/usr/lib/ocaml
+ OCAMLBUILD_LIBDIR=/usr/lib/ocaml \
+ OCAMLBUILD_MANDIR=/usr/share/man
+
+# these variables from your shell can interfere with tests. it should not be
+# necessary for buildds, but do it here for convenience.
+unexport OCAMLPARAM
+unexport OCAML_TOPLEVEL_PATH
+
+ifeq ($(DEB_HOST_ARCH),powerpc)
+# Suppress "bss-plt forced" warnings from ld
+# see https://github.com/ocaml/ocamlbuild/issues/254
+export PATH := $(CURDIR)/debian/bin:$(PATH)
+endif
 
 override_dh_auto_configure:
 	$(MAKE) $(OCAMLBUILD_CFG) OCAML_NATIVE=$(OCAML_NATIVE) configure

## ocamlbuild 0.14.1

=== Makefile ===
--- 
+++ 
@@ -30,7 +30,7 @@
 endif
 
 CP        ?= cp
-COMPFLAGS ?= -w L -w R -w Z -I src -I +unix -safe-string -bin-annot -strict-sequence
+COMPFLAGS ?= -w +L -w +R -w +Z -I src -I +unix -safe-string -bin-annot -strict-sequence
 LINKFLAGS ?= -I +unix -I src
 
 PACK_CMO= $(addprefix src/,\

=== bootstrap/Makefile ===
OCAMLBUILD ?= ocamlbuild

all: stage2

setup:
	$(MAKE) -C .. clean
	$(MAKE) -C .. src/ocamlbuild_config.ml
	ln -sf ../src
	mkdir -p bin

stage1: setup
	@echo "BOOTSTRAP (1): building local ocamlbuild from '$(OCAMLBUILD)'"
	@$(OCAMLBUILD) -build-dir _build_stage1 bootstrap.otarget

stage2: stage1
	@echo "BOOTSTRAP (2): building local ocamlbuild from local ocamlbuild"
	@_build_stage1/src/ocamlbuild.native -build-dir _build_stage2 bootstrap.otarget

clean:
	@$(OCAMLBUILD) -clean
	@$(OCAMLBUILD) -build-dir _build_stage1 -clean
	@$(OCAMLBUILD) -build-dir _build_stage2 -clean
	@rm -f src
	@rm -f bin/ocamlbuild_{stage1,stage2}.native
	@rmdir bin

=== examples/Makefile ===
.PHONY: all test clean

all: 	
	for d in [0-9]*-*; do $(MAKE) -C $$d all; done

test:
	for d in [0-9]*-*; do $(MAKE) -C $$d test; done

clean:
	for d in [0-9]*-*; do $(MAKE) -C $$d clean; done

=== examples/01-simple/Makefile ===
#
# Pure OCaml, no packages, no _tags
#

# bin-annot is required for Merlin and other IDE-like tools

.PHONY:	all clean byte native profile debug test

OCB_FLAGS = -tag bin_annot
OCB = 		ocamlbuild $(OCB_FLAGS)

all: native byte # profile debug

clean:
	$(OCB) -clean

native:
	$(OCB) main.native

byte:
	$(OCB) main.byte

profile:
	$(OCB) -tag profile main.native

debug:
	$(OCB) -tag debug main.byte

test: native
	./main.native "OCaml" "OCamlBuild" "users"

=== examples/05-lex-yacc/Makefile ===
#
# Pure OCaml, package from Opam, two directories
#

# - The -I flag introduces sub-directories
# - -use-ocamlfind is required to find packages (from Opam)
# - _tags file introduces packages, bin_annot flag for tool chain
# - using *.mll and *.mly are handled automatically

# - we are using menhir, the modern replacement for OCamlYacc
# OCB_FLAGS = -use-ocamlfind             -I src -I lib # uses ocamlyacc
.PHONY: 	all clean byte native profile debug sanity test

OCB_FLAGS   = -use-ocamlfind -use-menhir -I src -I lib # uses menhir
OCB = ocamlbuild $(OCB_FLAGS)

all: native byte # profile debug

clean:
	$(OCB) -clean

native: sanity
	$(OCB) main.native

byte: sanity
	$(OCB) main.byte

profile: sanity
	$(OCB) -tag profile main.native

debug: sanity
	$(OCB) -tag debug main.byte

# check that menhir is installed, use "opam install menhir"
sanity:
	which menhir

test: native
	./main.native "2 + 3 * 3"

=== examples/07-dependent-projects/Makefile ===
#
# Pure OCaml, project depends on library code from a local project
#
# For more details, see:
# https://ocaml.org/learn/tutorials/ocamlbuild/Working_on_dependent_projects_with_ocamlbuild.html
#

# - The -I flag introduces sub-directories

.PHONY: all clean byte native profile debug test

OCB_FLAGS = -I src -I libdemo
OCB = ocamlbuild $(OCB_FLAGS)

all: native byte

clean:
	$(OCB) -clean

native:
	$(OCB) main.native

byte:
	$(OCB) main.byte

profile:
	$(OCB) -tag profile main.native

debug:
	$(OCB) -tag debug main.byte

test: native
	./main.native groucho harpo chico

=== debian/changelog ===
ocamlbuild (0.14.1-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Mon, 21 Feb 2022 05:29:17 +0100

ocamlbuild (0.14.0-3) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Depend on ocaml-base-$ABI instead of ocaml-base-nox-$ABI
  * Bump Standards-Version to 4.6.0

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Stéphane Glondu <glondu@debian.org>  Thu, 20 Jan 2022 13:05:28 +0100

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-ocaml,
- ocaml-nox (>= 4.04.0),
+ ocaml,
  ocaml-findlib (>= 1.7.3),
  libfindlib-ocaml-dev (>= 1.7.3),
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/ocaml/ocamlbuild/
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocamlbuild.git

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 OCAMLABI = $(shell ocamlc -version)
 # to test a bytecode build on an architecture with ocamlopt, set this to "yes"
 BYTECODE = $(shell [ -x /usr/bin/ocamlopt ] || echo yes)
-OCAMLRUN = $(if $(BYTECODE),ocaml-base-nox-$(OCAMLABI))
+OCAMLRUN = $(if $(BYTECODE),ocaml-base-$(OCAMLABI))
 OCAML_NATIVE = $(if $(BYTECODE),false,true)
 
 OCAMLBUILD_CFG = \

## ocamlbuild 0.14.2

=== debian/changelog ===
ocamlbuild (0.14.2-2) unstable; urgency=medium

  * Team upload
  * Fix FTBFS on bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Mon, 28 Aug 2023 07:56:49 +0200

ocamlbuild (0.14.2-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Compute an ABI hash for ocamlbuild


  [ Julien Puydt ]
  * New upstream release.
  * Bump standards-version to 4.6.2.

 -- Stéphane Glondu <glondu@debian.org>  Mon, 28 Aug 2023 06:24:41 +0200

## ocamlbuild 0.14.3

=== Makefile ===
--- 
+++ 
@@ -30,7 +30,7 @@
 endif
 
 CP        ?= cp
-COMPFLAGS ?= -w +L -w +R -w +Z -I src -I +unix -safe-string -bin-annot -strict-sequence
+COMPFLAGS ?= -w +L -w +R -w +Z -I src -I plugin-lib -I bin -I +unix -safe-string -bin-annot -strict-sequence
 LINKFLAGS ?= -I +unix -I src
 
 PACK_CMO= $(addprefix src/,\
@@ -79,7 +79,7 @@
   main.cmo \
   )
 
-EXTRA_CMO=$(addprefix src/,\
+EXTRA_CMO=$(addprefix plugin-lib/,\
   ocamlbuild_plugin.cmo \
   ocamlbuild_executor.cmo \
   ocamlbuild_unix_plugin.cmo \
@@ -90,14 +90,14 @@
 EXTRA_CMI=$(EXTRA_CMO:.cmo=.cmi)
 
 INSTALL_LIB=\
-  src/ocamlbuildlib.cma \
-  src/ocamlbuild.cmo \
+  plugin-lib/ocamlbuildlib.cma \
+  bin/ocamlbuild.cmo \
   src/ocamlbuild_pack.cmi \
   $(EXTRA_CMO:.cmo=.cmi)
 
 INSTALL_LIB_OPT=\
-  src/ocamlbuildlib.cmxa src/ocamlbuildlib$(EXT_LIB) \
-  src/ocamlbuild.cmx src/ocamlbuild$(EXT_OBJ) \
+  plugin-lib/ocamlbuildlib.cmxa plugin-lib/ocamlbuildlib$(EXT_LIB) \
+  bin/ocamlbuild.cmx bin/ocamlbuild$(EXT_OBJ) \
   src/ocamlbuild_pack.cmx \
   $(EXTRA_CMO:.cmo=.cmx) $(EXTRA_CMO:.cmo=$(EXT_OBJ))
 
@@ -116,9 +116,9 @@
 all: byte man
 endif
 
-byte: ocamlbuild.byte src/ocamlbuildlib.cma
+byte: ocamlbuild.byte plugin-lib/ocamlbuildlib.cma
                  # ocamlbuildlight.byte ocamlbuildlightlib.cma
-native: ocamlbuild.native src/ocamlbuildlib.cmxa
+native: ocamlbuild.native plugin-lib/ocamlbuildlib.cmxa
 
 allopt: all # compatibility alias
 
@@ -126,24 +126,24 @@
 
 # The executables
 
-ocamlbuild.byte: src/ocamlbuild_pack.cmo $(EXTRA_CMO) src/ocamlbuild.cmo
+ocamlbuild.byte: src/ocamlbuild_pack.cmo $(EXTRA_CMO) bin/ocamlbuild.cmo
 	$(OCAMLC) $(LINKFLAGS) -o $@ unix.cma $^
 
-ocamlbuildlight.byte: src/ocamlbuild_pack.cmo src/ocamlbuildlight.cmo
+ocamlbuildlight.byte: src/ocamlbuild_pack.cmo bin/ocamlbuildlight.cmo
 	$(OCAMLC) $(LINKFLAGS) -o $@ $^
 
-ocamlbuild.native: src/ocamlbuild_pack.cmx $(EXTRA_CMX) src/ocamlbuild.cmx
+ocamlbuild.native: src/ocamlbuild_pack.cmx $(EXTRA_CMX) bin/ocamlbuild.cmx
 	$(OCAMLOPT) $(LINKFLAGS) -o $@ unix.cmxa $^
 
 # The libraries
 
-src/ocamlbuildlib.cma: src/ocamlbuild_pack.cmo $(EXTRA_CMO)
+plugin-lib/ocamlbuildlib.cma: src/ocamlbuild_pack.cmo $(EXTRA_CMO)
 	$(OCAMLC) -a -o $@ $^
 
-src/ocamlbuildlightlib.cma: src/ocamlbuild_pack.cmo src/ocamlbuildlight.cmo
+bin/ocamlbuildlightlib.cma: src/ocamlbuild_pack.cmo bin/ocamlbuildlight.cmo
 	$(OCAMLC) -a -o $@ $^
 
-src/ocamlbuildlib.cmxa: src/ocamlbuild_pack.cmx $(EXTRA_CMX)
+plugin-lib/ocamlbuildlib.cmxa: src/ocamlbuild_pack.cmx $(EXTRA_CMX)
 	$(OCAMLOPT) -a -o $@ $^
 
 # The packs
@@ -249,16 +249,16 @@
 # - producing an OPAM .install file and not actually installing anything
 
 install-bin-byte:
-	mkdir -p $(INSTALL_BINDIR)
-	$(CP) ocamlbuild.byte $(INSTALL_BINDIR)/ocamlbuild.byte$(EXE)
+	mkdir -p "$(INSTALL_BINDIR)"
+	$(CP) ocamlbuild.byte "$(INSTALL_BINDIR)/ocamlbuild.byte$(EXE)"
 ifneq ($(OCAML_NATIVE), true)
-	$(CP) ocamlbuild.byte $(INSTALL_BINDIR)/ocamlbuild$(EXE)
+	$(CP) ocamlbuild.byte "$(INSTALL_BINDIR)/ocamlbuild$(EXE)"
 endif
 
 install-bin-native:
-	mkdir -p $(INSTALL_BINDIR)
-	$(CP) ocamlbuild.native $(INSTALL_BINDIR)/ocamlbuild$(EXE)
-	$(CP) ocamlbuild.native $(INSTALL_BINDIR)/ocamlbuild.native$(EXE)
+	mkdir -p "$(INSTALL_BINDIR)"
+	$(CP) ocamlbuild.native "$(INSTALL_BINDIR)/ocamlbuild$(EXE)"
+	$(CP) ocamlbuild.native "$(INSTALL_BINDIR)/ocamlbuild.native$(EXE)"
 
 ifeq ($(OCAML_NATIVE), true)
 install-bin: install-bin-byte install-bin-native
@@ -279,8 +279,8 @@
 	echo >> ocamlbuild.install
 
 install-lib-basics:
-	mkdir -p $(INSTALL_LIBDIR)/ocamlbuild
-	$(CP) META $(INSTALL_SIGNATURES) $(INSTALL_LIBDIR)/ocamlbuild
+	mkdir -p "$(INSTALL_LIBDIR)/ocamlbuild"
+	$(CP) META $(INSTALL_SIGNATURES) "$(INSTALL_LIBDIR)/ocamlbuild"
 
 install-lib-basics-opam:
 	echo '  "ocamlbuild.opam" {"opam"}' >> ocamlbuild.install
@@ -290,8 +290,8 @@
 	done
 
 install-lib-byte:
-	mkdir -p $(INSTALL_LIBDIR)/ocamlbuild
-	$(CP) $(INSTALL_LIB) $(INSTALL_LIBDIR)/ocamlbuild
+	mkdir -p "$(INSTALL_LIBDIR)/ocamlbuild"
+	$(CP) $(INSTALL_LIB) "$(INSTALL_LIBDIR)/ocamlbuild"
 
 install-lib-byte-opam:
 	for lib in $(INSTALL_LIB); do \
@@ -299,8 +299,8 @@
 	done
 
 install-lib-native:
-	mkdir -p $(INSTALL_LIBDIR)/ocamlbuild
-	$(CP) $(INSTALL_LIB_OPT) $(INSTALL_LIBDIR)/ocamlbuild
+	mkdir -p "$(INSTALL_LIBDIR)/ocamlbuild"
+	$(CP) $(INSTALL_LIB_OPT) "$(INSTALL_LIBDIR)/ocamlbuild"
 
 install-lib-native-opam:
 	for lib in $(INSTALL_LIB_OPT); do \
@@ -333,8 +333,8 @@
 	echo >> ocamlbuild.install
 
 install-man:
-	mkdir -p $(INSTALL_MANDIR)/man1
-	cp man/ocamlbuild.1 $(INSTALL_MANDIR)/man1/ocamlbuild.1
+	mkdir -p "$(INSTALL_MANDIR)/man1"
+	cp man/ocamlbuild.1 "$(INSTALL_MANDIR)/man1/ocamlbuild.1"
 
 install-man-opam:
 	echo 'man: [' >> ocamlbuild.install
@@ -377,14 +377,14 @@
 ifeq ($(OCAML_NATIVE), true)
 	$(MAKE) uninstall-lib-native
 endif
-	ls $(LIBDIR)/ocamlbuild # for easier debugging if rmdir fails
-	rmdir $(LIBDIR)/ocamlbuild
+	ls "$(LIBDIR)/ocamlbuild" # for easier debugging if rmdir fails
+	rmdir "$(LIBDIR)/ocamlbuild"
 
 uninstall-lib-findlib:
 	ocamlfind remove ocamlbuild
 
 uninstall-man:
-	rm $(INSTALL_MANDIR)/man1/ocamlbuild.1
+	rm "$(INSTALL_MANDIR)/man1/ocamlbuild.1"
 
 install: check-if-preinstalled
 	$(MAKE) install-bin install-lib install-man
@@ -424,8 +424,14 @@
 %.cmi: %.mli
 	$(OCAMLC) $(COMPFLAGS) -c $<
 
-%.cmx: %.ml
+src/%.cmx: src/%.ml
 	$(OCAMLOPT) -for-pack Ocamlbuild_pack $(COMPFLAGS) -c $<
+
+bin/%.cmx: bin/%.ml
+	$(OCAMLOPT) $(COMPFLAGS) -c $<
+
+plugin-lib/%.cmx: plugin-lib/%.ml
+	$(OCAMLOPT) $(COMPFLAGS) -c $<
 
 clean::
 	rm -rf tmp/
@@ -445,14 +451,6 @@
 # The dependencies
 
 depend: beforedepend
-	$(OCAMLDEP) -I src src/*.mli src/*.ml > .depend
+	$(OCAMLDEP) -I src -I plugin-lib src/*.mli src/*.ml plugin-lib/*.mli plugin-lib/*.ml bin/*.mli bin/*.ml > .depend
 
 $(EXTRA_CMI): src/ocamlbuild_pack.cmi
-$(EXTRA_CMO): src/ocamlbuild_pack.cmo src/ocamlbuild_pack.cmi
-$(EXTRA_CMX): src/ocamlbuild_pack.cmx src/ocamlbuild_pack.cmi
-
-include .depend
-
-.PHONY: all allopt beforedepend clean configure
-.PHONY: install installopt installopt_really depend
-

=== bootstrap/Makefile ===
OCAMLBUILD ?= ocamlbuild

all: stage2

setup:
	$(MAKE) -C .. clean
	$(MAKE) -C .. src/ocamlbuild_config.ml
	ln -sf ../src
	ln -sf ../bin
	ln -sf ../plugin-lib
	mkdir -p dest

stage1: setup
	@echo "BOOTSTRAP (1): building local ocamlbuild from '$(OCAMLBUILD)'"
	@$(OCAMLBUILD) -build-dir _build_stage1 bootstrap.otarget

stage2: stage1
	@echo "BOOTSTRAP (2): building local ocamlbuild from local ocamlbuild"
	@_build_stage1/bin/ocamlbuild.native -build-dir _build_stage2 bootstrap.otarget

clean:
	@$(OCAMLBUILD) -clean
	@$(OCAMLBUILD) -build-dir _build_stage1 -clean
	@$(OCAMLBUILD) -build-dir _build_stage2 -clean
	@rm -f src bin plugin-lib
	@rm -f dest/ocamlbuild_{stage1,stage2}.native
	@rmdir dest

=== debian/changelog ===
ocamlbuild (0.14.3-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 14 Feb 2024 17:31:10 +0100

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-ocaml,
- ocaml,
- ocaml-findlib (>= 1.7.3),
- libfindlib-ocaml-dev (>= 1.7.3),
-Standards-Version: 4.6.0
+ ocaml (>= 4.13.1),
+ ocaml-findlib,
+ libfindlib-ocaml-dev,
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/ocaml/ocamlbuild/
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocamlbuild.git
@@ -17,10 +17,8 @@
 
 Package: ocamlbuild
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${F:OCamlRun}, ${ocaml:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${ocaml:Depends}
 Provides: ${ocaml:Provides}
-Replaces: libfindlib-ocaml (<< 1.6.3-1), ocaml-nox (<< 4.03.0-1)
-Breaks: libfindlib-ocaml (<< 1.6.3-1), ocaml-nox (<< 4.03.0-1)
 Description: Build tool for building OCaml libraries and programs
  OCamlbuild is a generic build tool, which has built-in rules for building OCaml
  libraries and programs.

=== debian/rules ===
--- 
+++ 
@@ -8,14 +8,9 @@
 
 %:
 	dh $@ --with ocaml
-# TODO: Add a lintian check: if any package contains .cmi files then it should
-# have a Depends: ocaml-base-nox or something like that (ask the list first).
 
-# see https://pkg-ocaml-maint.alioth.debian.org/ocaml_packaging_policy.txt
-OCAMLABI = $(shell ocamlc -version)
 # to test a bytecode build on an architecture with ocamlopt, set this to "yes"
 BYTECODE = $(shell [ -x /usr/bin/ocamlopt ] || echo yes)
-OCAMLRUN = $(if $(BYTECODE),ocaml-base-$(OCAMLABI))
 OCAML_NATIVE = $(if $(BYTECODE),false,true)
 
 OCAMLBUILD_CFG = \
@@ -42,9 +37,13 @@
 	dh_auto_install -- CHECK_IF_PREINSTALLED=false
 	cd debian/ocamlbuild/usr/bin && rm -f ocamlbuild.byte ocamlbuild.native
 
-override_dh_auto_clean:
-	dh_auto_clean
-	find . -name '*.cmti' -delete
+override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	mkdir -p _tmp
+	cp plugin-lib/* bin/*.cm* $(wildcard bin/*.o) _tmp
+	$(MAKE) test
+	rm -rf _tmp
+endif
 
-override_dh_gencontrol:
-	dh_gencontrol -- -VF:OCamlRun="$(OCAMLRUN)"
+override_dh_ocaml:
+	dh_ocaml --runtime-map=ocamlbuild

## ocamlbuild 0.15.0

=== Makefile ===
--- 
+++ 
@@ -30,15 +30,17 @@
 endif
 
 CP        ?= cp
-COMPFLAGS ?= -w +L -w +R -w +Z -I src -I plugin-lib -I bin -I +unix -safe-string -bin-annot -strict-sequence
-LINKFLAGS ?= -I +unix -I src
+OCB_COMPFLAGS ?= -w @14@29 -w +L -w +R -w +Z -I src -I plugin-lib -I bin -I +unix -safe-string -bin-annot -strict-sequence
+OCB_LINKFLAGS ?= -I +unix -I src
 
 PACK_CMO= $(addprefix src/,\
   const.cmo \
   loc.cmo \
   discard_printf.cmo \
   signatures.cmi \
+  exit_codes.cmo \
   my_std.cmo \
+  ocamlbuild_executor.cmo \
   my_unix.cmo \
   tags.cmo \
   display.cmo \
@@ -73,7 +75,6 @@
   ocaml_compiler.cmo \
   ocaml_tools.cmo \
   ocaml_specific.cmo \
-  exit_codes.cmo \
   plugin.cmo \
   hooks.cmo \
   main.cmo \
@@ -81,7 +82,6 @@
 
 EXTRA_CMO=$(addprefix plugin-lib/,\
   ocamlbuild_plugin.cmo \
-  ocamlbuild_executor.cmo \
   ocamlbuild_unix_plugin.cmo \
   )
 
@@ -117,7 +117,7 @@
 endif
 
 byte: ocamlbuild.byte plugin-lib/ocamlbuildlib.cma
-                 # ocamlbuildlight.byte ocamlbuildlightlib.cma
+
 native: ocamlbuild.native plugin-lib/ocamlbuildlib.cmxa
 
 allopt: all # compatibility alias
@@ -127,20 +127,14 @@
 # The executables
 
 ocamlbuild.byte: src/ocamlbuild_pack.cmo $(EXTRA_CMO) bin/ocamlbuild.cmo
-	$(OCAMLC) $(LINKFLAGS) -o $@ unix.cma $^
-
-ocamlbuildlight.byte: src/ocamlbuild_pack.cmo bin/ocamlbuildlight.cmo
-	$(OCAMLC) $(LINKFLAGS) -o $@ $^
+	$(OCAMLC) $(OCB_LINKFLAGS) -o $@ -I +unix unix.cma $^
 
 ocamlbuild.native: src/ocamlbuild_pack.cmx $(EXTRA_CMX) bin/ocamlbuild.cmx
-	$(OCAMLOPT) $(LINKFLAGS) -o $@ unix.cmxa $^
+	$(OCAMLOPT) $(OCB_LINKFLAGS) -o $@ -I +unix unix.cmxa $^
 
 # The libraries
 
 plugin-lib/ocamlbuildlib.cma: src/ocamlbuild_pack.cmo $(EXTRA_CMO)
-	$(OCAMLC) -a -o $@ $^
-
-bin/ocamlbuildlightlib.cma: src/ocamlbuild_pack.cmo bin/ocamlbuildlight.cmo
 	$(OCAMLC) -a -o $@ $^
 
 plugin-lib/ocamlbuildlib.cmxa: src/ocamlbuild_pack.cmx $(EXTRA_CMX)
@@ -213,7 +207,7 @@
 	rm -f man/ocamlbuild.1
 
 man/options_man.byte: src/ocamlbuild_pack.cmo
-	$(OCAMLC) $^ -I src man/options_man.ml -o man/options_man.byte
+	$(OCAMLC) -I +unix unix.cma $^ -I src man/options_man.ml -o man/options_man.byte
 
 clean::
 	rm -f man/options_man.cm*
@@ -225,7 +219,7 @@
 # Testing
 
 test-%: testsuite/%.ml all
-	cd testsuite && ocaml $(CURDIR)/$<
+	cd testsuite && ocaml -w @14@29 "../$<"
 
 test: test-internal test-findlibonly test-external
 
@@ -268,12 +262,12 @@
 
 install-bin-opam:
 	echo 'bin: [' >> ocamlbuild.install
-	echo '  "ocamlbuild.byte" {"ocamlbuild.byte"}' >> ocamlbuild.install
-ifeq ($(OCAML_NATIVE), true)
-	echo '  "ocamlbuild.native" {"ocamlbuild.native"}' >> ocamlbuild.install
-	echo '  "ocamlbuild.native" {"ocamlbuild"}' >> ocamlbuild.install
-else
-	echo '  "ocamlbuild.byte" {"ocamlbuild"}' >> ocamlbuild.install
+	echo '  "ocamlbuild.byte" {"ocamlbuild.byte$(EXE)"}' >> ocamlbuild.install
+ifeq ($(OCAML_NATIVE), true)
+	echo '  "ocamlbuild.native" {"ocamlbuild.native$(EXE)"}' >> ocamlbuild.install
+	echo '  "ocamlbuild.native" {"ocamlbuild$(EXE)"}' >> ocamlbuild.install
+else
+	echo '  "ocamlbuild.byte" {"ocamlbuild$(EXE)"}' >> ocamlbuild.install
 endif
 	echo ']' >> ocamlbuild.install
 	echo >> ocamlbuild.install
@@ -419,28 +413,29 @@
 # The generic rules
 
 %.cmo: %.ml
-	$(OCAMLC) $(COMPFLAGS) -c $<
+	$(OCAMLC) $(OCB_COMPFLAGS) -c $<
 
 %.cmi: %.mli
-	$(OCAMLC) $(COMPFLAGS) -c $<
+	$(OCAMLC) $(OCB_COMPFLAGS) -c $<
 
 src/%.cmx: src/%.ml
-	$(OCAMLOPT) -for-pack Ocamlbuild_pack $(COMPFLAGS) -c $<
+	$(OCAMLOPT) -for-pack Ocamlbuild_pack $(OCB_COMPFLAGS) -c $<
 
 bin/%.cmx: bin/%.ml
-	$(OCAMLOPT) $(COMPFLAGS) -c $<
+	$(OCAMLOPT) $(OCB_COMPFLAGS) -c $<
 
 plugin-lib/%.cmx: plugin-lib/%.ml
-	$(OCAMLOPT) $(COMPFLAGS) -c $<
+	$(OCAMLOPT) $(OCB_COMPFLAGS) -c $<
 
 clean::
 	rm -rf tmp/
-	rm -f src/*.cm* *.cm*
+	rm -f src/*.cm* *.cm* bin/*.cm* plugin-lib/*.cm*
+	rm -f src/*.o *.o bin/*.o plugin-lib/*.o plugin-lib/*.a
 ifdef EXT_OBJ
-	rm -f src/*$(EXT_OBJ) *$(EXT_OBJ)
+	rm -f src/*$(EXT_OBJ) bin/*$(EXT_OBJ) plugin-lib/*$(EXT_OBJ) *$(EXT_OBJ)
 endif
 ifdef EXT_LIB
-	rm -f src/*$(EXT_LIB) *$(EXT_LIB)
+	rm -f src/*$(EXT_LIB) bin/*$(EXT_LIB) plugin-lib/*$(EXT_LIB) *$(EXT_LIB)
 endif
 	rm -f test/test2/vivi.ml
 
@@ -451,6 +446,6 @@
 # The dependencies
 
 depend: beforedepend
-	$(OCAMLDEP) -I src -I plugin-lib src/*.mli src/*.ml plugin-lib/*.mli plugin-lib/*.ml bin/*.mli bin/*.ml > .depend
+	$(OCAMLDEP) -I src -I plugin-lib -I bin src/*.mli src/*.ml plugin-lib/*.mli plugin-lib/*.ml bin/*.mli bin/*.ml > .depend
 
 $(EXTRA_CMI): src/ocamlbuild_pack.cmi

=== debian/changelog ===
ocamlbuild (0.15.0-2build1) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 09 Aug 2024 14:18:37 +0200

ocamlbuild (0.15.0-2) unstable; urgency=medium

  * Team upload
  * Add support for a different OCaml stdlib dir

 -- Stéphane Glondu <glondu@debian.org>  Sat, 03 Aug 2024 05:11:13 +0200

ocamlbuild (0.15.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Fri, 12 Jul 2024 14:00:30 +0200

ocamlbuild (0.14.3-2) unstable; urgency=medium

  * Team upload
  * Disable tests that fail stupidly with OCaml 5.2.0

 -- Stéphane Glondu <glondu@debian.org>  Sat, 15 Jun 2024 07:53:22 +0200
